diff --git a/src/ui/qgsgpsinformationwidgetbase.ui b/src/ui/qgsgpsinformationwidgetbase.ui
index edcf642..689b95d 100644
--- a/src/ui/qgsgpsinformationwidgetbase.ui
+++ b/src/ui/qgsgpsinformationwidgetbase.ui
@@ -414,110 +797,225 @@
                 </item>
                </layout>
               </item>
-              <item row="5" column="0">
+              <item row="4" column="0">
                <widget class="QRadioButton" name="mRadGpsd">
                 <property name="text">
-                 <string>Connection to gpsd</string>
+                 <string>gpsd</string>
                 </property>
                </widget>
               </item>
              </layout>
             </widget>
            </item>
-           <item row="1" column="0">
-            <widget class="QGroupBox" name="mGroupShowMarker">
+           <item row="2" column="0">
+            <widget class="QGroupBox" name="groupBox_2">
              <property name="title">
-              <string>GPS cursor size</string>
-             </property>
-             <property name="checkable">
-              <bool>true</bool>
+              <string>Digitizing</string>
              </property>
-             <layout class="QGridLayout" name="gridLayout_3">
-              <item row="0" column="0" colspan="3">
-               <widget class="QSlider" name="mSliderMarkerSize">
-                <property name="minimum">
-                 <number>8</number>
-                </property>
-                <property name="maximum">
-                 <number>128</number>
-                </property>
-                <property name="singleStep">
-                 <number>4</number>
-                </property>
-                <property name="pageStep">
-                 <number>8</number>
-                </property>
-                <property name="sliderPosition">
-                 <number>10</number>
-                </property>
-                <property name="orientation">
-                 <enum>Qt::Horizontal</enum>
-                </property>
-                <property name="tickPosition">
-                 <enum>QSlider::TicksBelow</enum>
-                </property>
-               </widget>
-              </item>
+             <layout class="QGridLayout" name="gridLayout_9">
+              <property name="topMargin">
+               <number>2</number>
+              </property>
+              <property name="bottomMargin">
+               <number>4</number>
+              </property>
+              <property name="verticalSpacing">
+               <number>2</number>
+              </property>
               <item row="1" column="0">
-               <widget class="QLabel" name="label">
-                <property name="text">
-                 <string>Small</string>
+               <widget class="QGroupBox" name="groupBox_3">
+                <property name="title">
+                 <string>Track</string>
                 </property>
+                <layout class="QVBoxLayout" name="verticalLayout">
+                 <property name="spacing">
+                  <number>2</number>
+                 </property>
+                 <property name="topMargin">
+                  <number>2</number>
+                 </property>
+                 <property name="bottomMargin">
+                  <number>4</number>
+                 </property>
+                 <item>
+                  <widget class="QCheckBox" name="mCbxAutoAddVertices">
+                   <property name="text">
+                    <string>Automatically add points</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <layout class="QHBoxLayout" name="horizontalLayout_7">
+                   <item>
+                    <widget class="QSpinBox" name="mSpinTrackWidth">
+                     <property name="toolTip">
+                      <string>Track width in pixels</string>
+                     </property>
+                     <property name="suffix">
+                      <string> width</string>
+                     </property>
+                    </widget>
+                   </item>
+                   <item>
+                    <widget class="QPushButton" name="mBtnTrackColour">
+                     <property name="styleSheet">
+                      <string/>
+                     </property>
+                     <property name="text">
+                      <string>Color</string>
+                     </property>
+                    </widget>
+                   </item>
+                  </layout>
+                 </item>
+                </layout>
                </widget>
               </item>
-              <item row="1" column="1">
-               <spacer name="horizontalSpacer_2">
-                <property name="orientation">
-                 <enum>Qt::Horizontal</enum>
-                </property>
-                <property name="sizeHint" stdset="0">
-                 <size>
-                  <width>207</width>
-                  <height>20</height>
-                 </size>
+              <item row="0" column="0">
+               <widget class="QCheckBox" name="mCbxAutoCommit">
+                <property name="toolTip">
+                 <string>save layer after every feature added</string>
                 </property>
-               </spacer>
-              </item>
-              <item row="1" column="2">
-               <widget class="QLabel" name="label_2">
                 <property name="text">
-                 <string>Large</string>
+                 <string>Automatically save added feature</string>
                 </property>
                </widget>
               </item>
              </layout>
             </widget>
            </item>
-           <item row="2" column="0">
-            <widget class="QGroupBox" name="groupBox_2">
+           <item row="5" column="0">
+            <widget class="QGroupBox" name="mLogFileGroupBox">
+             <property name="enabled">
+              <bool>true</bool>
+             </property>
+             <property name="minimumSize">
+              <size>
+               <width>0</width>
+               <height>0</height>
+              </size>
+             </property>
+             <property name="toolTip">
+              <string>save GPS data (NMEA sentences) to a file</string>
+             </property>
              <property name="title">
-              <string>GPS digitizing</string>
+              <string>Log File</string>
              </property>
-             <layout class="QGridLayout" name="gridLayout_9">
+             <property name="checkable">
+              <bool>true</bool>
+             </property>
+             <property name="checked">
+              <bool>false</bool>
+             </property>
+             <layout class="QGridLayout" name="gridLayout_13" columnstretch="100,0">
+              <property name="topMargin">
+               <number>2</number>
+              </property>
+              <property name="bottomMargin">
+               <number>4</number>
+              </property>
               <item row="0" column="0">
-               <widget class="QCheckBox" name="mCbxAutoAddVertices">
+               <widget class="QLineEdit" name="mTxtLogFile">
+                <property name="enabled">
+                 <bool>true</bool>
+                </property>
+                <property name="sizePolicy">
+                 <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                  <horstretch>0</horstretch>
+                  <verstretch>0</verstretch>
+                 </sizepolicy>
+                </property>
+                <property name="acceptDrops">
+                 <bool>false</bool>
+                </property>
+                <property name="readOnly">
+                 <bool>true</bool>
+                </property>
+               </widget>
+              </item>
+              <item row="0" column="1">
+               <widget class="QPushButton" name="mBtnLogFile">
+                <property name="sizePolicy">
+                 <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
+                  <horstretch>23</horstretch>
+                  <verstretch>0</verstretch>
+                 </sizepolicy>
+                </property>
+                <property name="minimumSize">
+                 <size>
+                  <width>23</width>
+                  <height>0</height>
+                 </size>
+                </property>
+                <property name="toolTip">
+                 <string>browse for log file</string>
+                </property>
                 <property name="text">
-                 <string>Auto-add vertices</string>
+                 <string>...</string>
                 </property>
                </widget>
               </item>
              </layout>
             </widget>
            </item>
-           <item row="3" column="0">
+           <item row="4" column="0">
             <widget class="QGroupBox" name="groupBox">
              <property name="title">
-              <string>GPS map recenter</string>
+              <string>Map centering</string>
              </property>
              <layout class="QGridLayout" name="gridLayout_8">
+              <property name="topMargin">
+               <number>2</number>
+              </property>
+              <property name="bottomMargin">
+               <number>4</number>
+              </property>
+              <property name="verticalSpacing">
+               <number>2</number>
+              </property>
               <item row="1" column="0">
                <widget class="QRadioButton" name="radRecenterWhenNeeded">
                 <property name="text">
-                 <string>when leaving extents</string>
+                 <string>when leaving</string>
                 </property>
                </widget>
               </item>
               <item row="2" column="0">
+               <layout class="QHBoxLayout" name="horizontalLayout">
+                <property name="leftMargin">
+                 <number>20</number>
+                </property>
+                <item>
+                 <widget class="QSpinBox" name="mSpinMapExtentMultiplier">
+                  <property name="enabled">
+                   <bool>false</bool>
+                  </property>
+                  <property name="sizePolicy">
+                   <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                    <horstretch>0</horstretch>
+                    <verstretch>0</verstretch>
+                   </sizepolicy>
+                  </property>
+                  <property name="suffix">
+                   <string>% of map extent</string>
+                  </property>
+                  <property name="minimum">
+                   <number>5</number>
+                  </property>
+                  <property name="maximum">
+                   <number>100</number>
+                  </property>
+                  <property name="singleStep">
+                   <number>1</number>
+                  </property>
+                  <property name="value">
+                   <number>50</number>
+                  </property>
+                 </widget>
+                </item>
+               </layout>
+              </item>
+              <item row="3" column="0">
                <widget class="QRadioButton" name="radNeverRecenter">
                 <property name="text">
                  <string>never</string>
@@ -537,26 +1035,91 @@
              </layout>
             </widget>
            </item>
-           <item row="4" column="0">
-            <widget class="QGroupBox" name="groupBox_3">
+           <item row="3" column="0">
+            <widget class="QGroupBox" name="mGroupShowMarker">
              <property name="title">
-              <string>Track</string>
+              <string>Cursor</string>
              </property>
-             <layout class="QGridLayout" name="gridLayout_11">
-              <item row="0" column="0">
-               <widget class="QPushButton" name="mBtnTrackColour">
-                <property name="styleSheet">
-                 <string/>
+             <property name="checkable">
+              <bool>true</bool>
+             </property>
+             <layout class="QGridLayout" name="gridLayout_3">
+              <property name="topMargin">
+               <number>4</number>
+              </property>
+              <property name="bottomMargin">
+               <number>4</number>
+              </property>
+              <property name="verticalSpacing">
+               <number>2</number>
+              </property>
+              <item row="0" column="0" colspan="3">
+               <widget class="QSlider" name="mSliderMarkerSize">
+                <property name="sizePolicy">
+                 <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                  <horstretch>0</horstretch>
+                  <verstretch>0</verstretch>
+                 </sizepolicy>
                 </property>
-                <property name="text">
-                 <string>Color</string>
+                <property name="minimum">
+                 <number>8</number>
+                </property>
+                <property name="maximum">
+                 <number>128</number>
+                </property>
+                <property name="singleStep">
+                 <number>4</number>
+                </property>
+                <property name="pageStep">
+                 <number>8</number>
+                </property>
+                <property name="sliderPosition">
+                 <number>10</number>
+                </property>
+                <property name="orientation">
+                 <enum>Qt::Horizontal</enum>
+                </property>
+                <property name="tickPosition">
+                 <enum>QSlider::TicksBelow</enum>
                 </property>
                </widget>
               </item>
               <item row="1" column="0">
-               <widget class="QSpinBox" name="mSpinTrackWidth">
-                <property name="suffix">
-                 <string> width</string>
+               <widget class="QLabel" name="label">
+                <property name="sizePolicy">
+                 <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                  <horstretch>0</horstretch>
+                  <verstretch>0</verstretch>
+                 </sizepolicy>
+                </property>
+                <property name="text">
+                 <string>Small</string>
+                </property>
+               </widget>
+              </item>
+              <item row="1" column="1">
+               <spacer name="horizontalSpacer_2">
+                <property name="orientation">
+                 <enum>Qt::Horizontal</enum>
+                </property>
+                <property name="sizeHint" stdset="0">
+                 <size>
+                  <width>20</width>
+                  <height>10</height>
+                 </size>
+                </property>
+               </spacer>
+              </item>
+              <item row="1" column="2">
+               <widget class="QLabel" name="label_2">
+                <property name="sizePolicy">
+                 <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                  <horstretch>0</horstretch>
+                  <verstretch>0</verstretch>
+                 </sizepolicy>
+                </property>
+                <property name="text">
+                 <string>Large</string>
                 </property>
                </widget>
               </item>
@@ -575,7 +1138,14 @@
         <number>0</number>
        </property>
        <item row="0" column="0">
-        <widget class="QTextEdit" name="mGPSTextEdit"/>
+        <widget class="QPlainTextEdit" name="mGPSPlainTextEdit">
+         <property name="acceptDrops">
+          <bool>false</bool>
+         </property>
+         <property name="undoRedoEnabled">
+          <bool>false</bool>
+         </property>
+        </widget>
        </item>
       </layout>
      </widget>
@@ -589,21 +1159,46 @@
   <tabstop>mBtnSatellites</tabstop>
   <tabstop>mBtnOptions</tabstop>
   <tabstop>mBtnDebug</tabstop>
-  <tabstop>mDateTime</tabstop>
-  <tabstop>mSpinLatitude</tabstop>
-  <tabstop>mSpinLongitude</tabstop>
-  <tabstop>mSpinElevation</tabstop>
-  <tabstop>mBtnAddVertex</tabstop>
+  <tabstop>mConnectButton</tabstop>
   <tabstop>mBtnCloseFeature</tabstop>
+  <tabstop>mBtnAddVertex</tabstop>
+  <tabstop>mBtnResetFeature</tabstop>
+  <tabstop>mTxtLatitude</tabstop>
+  <tabstop>mTxtLongitude</tabstop>
+  <tabstop>mTxtAltitude</tabstop>
+  <tabstop>mTxtDateTime</tabstop>
+  <tabstop>mTxtSpeed</tabstop>
+  <tabstop>mTxtDirection</tabstop>
+  <tabstop>mTxtHdop</tabstop>
+  <tabstop>mTxtVdop</tabstop>
+  <tabstop>mTxtPdop</tabstop>
+  <tabstop>mTxtFixMode</tabstop>
+  <tabstop>mTxtFixType</tabstop>
+  <tabstop>mTxtQuality</tabstop>
+  <tabstop>mTxtStatus</tabstop>
+  <tabstop>mTxtSatellitesUsed</tabstop>
   <tabstop>mRadAutodetect</tabstop>
   <tabstop>mRadUserPath</tabstop>
   <tabstop>mCboDevices</tabstop>
+  <tabstop>mBtnRefreshDevices</tabstop>
+  <tabstop>mRadGpsd</tabstop>
+  <tabstop>mGpsdHost</tabstop>
+  <tabstop>mGpsdPort</tabstop>
+  <tabstop>mGpsdDevice</tabstop>
+  <tabstop>mCbxAutoCommit</tabstop>
+  <tabstop>mCbxAutoAddVertices</tabstop>
+  <tabstop>mSpinTrackWidth</tabstop>
+  <tabstop>mBtnTrackColour</tabstop>
   <tabstop>mGroupShowMarker</tabstop>
   <tabstop>mSliderMarkerSize</tabstop>
   <tabstop>radRecenterMap</tabstop>
   <tabstop>radRecenterWhenNeeded</tabstop>
+  <tabstop>mSpinMapExtentMultiplier</tabstop>
   <tabstop>radNeverRecenter</tabstop>
-  <tabstop>mGPSTextEdit</tabstop>
+  <tabstop>mLogFileGroupBox</tabstop>
+  <tabstop>mTxtLogFile</tabstop>
+  <tabstop>mBtnLogFile</tabstop>
+  <tabstop>mGPSPlainTextEdit</tabstop>
  </tabstops>
  <resources>
   <include location="../../images/images.qrc"/>
@@ -612,22 +1207,6 @@
   <connection>
    <sender>mRadAutodetect</sender>
    <signal>toggled(bool)</signal>
-   <receiver>mPathLabel</receiver>
-   <slot>setDisabled(bool)</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>114</x>
-     <y>65</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>101</x>
-     <y>122</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>mRadAutodetect</sender>
-   <signal>toggled(bool)</signal>
    <receiver>mCboDevices</receiver>
    <slot>setDisabled(bool)</slot>
    <hints>
@@ -644,22 +1223,6 @@
   <connection>
    <sender>mRadUserPath</sender>
    <signal>toggled(bool)</signal>
-   <receiver>mPathLabel</receiver>
-   <slot>setEnabled(bool)</slot>
-   <hints>
-    <hint type="sourcelabel">
-     <x>208</x>
-     <y>93</y>
-    </hint>
-    <hint type="destinationlabel">
-     <x>207</x>
-     <y>122</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>mRadUserPath</sender>
-   <signal>toggled(bool)</signal>
    <receiver>mCboDevices</receiver>
    <slot>setEnabled(bool)</slot>
    <hints>
@@ -897,5 +1460,101 @@
     </hint>
    </hints>
   </connection>
+  <connection>
+   <sender>radRecenterWhenNeeded</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mSpinMapExtentMultiplier</receiver>
+   <slot>setEnabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>132</x>
+     <y>339</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>141</x>
+     <y>360</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>radRecenterMap</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mSpinMapExtentMultiplier</receiver>
+   <slot>setDisabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>132</x>
+     <y>320</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>141</x>
+     <y>360</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>radNeverRecenter</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mSpinMapExtentMultiplier</receiver>
+   <slot>setDisabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>132</x>
+     <y>382</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>141</x>
+     <y>360</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>mCbxAutoAddVertices</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mBtnAddVertex</receiver>
+   <slot>setDisabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>94</x>
+     <y>348</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>122</x>
+     <y>41</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>mConnectButton</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mDeviceGroupBox</receiver>
+   <slot>setDisabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>191</x>
+     <y>71</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>107</x>
+     <y>173</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>mConnectButton</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mLogFileGroupBox</receiver>
+   <slot>setDisabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>191</x>
+     <y>71</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>107</x>
+     <y>563</y>
+    </hint>
+   </hints>
+  </connection>
  </connections>
 </ui>
